#ifndef __ACM_FCF_SYMBOL_LIBRARY_H
#define __ACM_FCF_SYMBOL_LIBRARY_H
//
//  (C) Copyright 2008 by Autodesk, Inc.  All rights reserved.
//
// Permission to use, copy, modify, and distribute this software in
// object code form for any purpose and without fee is hereby granted, 
// provided that the above copyright notice appears in all copies and 
// that both that copyright notice and the limited warranty and
// restricted rights notice below appear in all supporting 
// documentation.
//
// AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS. 
// AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
// MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC. 
// DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
// UNINTERRUPTED OR ERROR FREE.
//
// Use, duplication, or disclosure by the U.S. Government is subject to 
// restrictions set forth in FAR 52.227-19 (Commercial Computer
// Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
// (Rights in Technical Data and Computer Software), as applicable.
//


#include "SymbolLib.h"

//////////////////////////////////////////////////////////////////////////
// class AmdtFCFLibObject
class DllImpExp AmdtFCFLibObject : public AmdtSymbolLibObject
{
public:
  ACRX_DECLARE_MEMBERS(AmdtFCFLibObject);
  AmdtFCFLibObject();
  ~AmdtFCFLibObject();

  virtual Acad::ErrorStatus dwgInFields (AcDbDwgFiler* pFiler);
  virtual Acad::ErrorStatus dwgOutFields(AcDbDwgFiler* pFiler) const;

  Acm::GdtSymbolType symbol() const;
  Acm::GdtSymbolType symbol2() const;
  Acm::GdtSymbolType symbol3() const;
  Adesk::Boolean isAllAround() const;
  
  bool operator==(const AmdtFCFLibObject& fcfLibObj)const;
protected:
  virtual Acad::ErrorStatus subGetClassID(CLSID* pClsid) const;
};
MAKE_ACDBOPENOBJECT_FUNCTION(AmdtFCFLibObject);
DBREF_DECLARE(AmdtFCFLibObject)


////////////////////////////////////////////////////////////////
// class AmdtFCFLibrary
class DllImpExp AmdtFCFLibrary : public AmdtSymbolLibrary
{
public:
  ACRX_DECLARE_MEMBERS(AmdtFCFLibrary);
  AmdtFCFLibrary();

  virtual const ACHAR *name() const;
  // Retrieve stored item
  virtual Acad::ErrorStatus loadItem(const ACHAR *entryName, AcmSymbol *pSym);

  // Add new item
  virtual Acad::ErrorStatus appendItem(const ACHAR *entryName, AcmSymbol *pSym, AcDbObjectId& id, bool bCheckValidName=true);
  virtual Acad::ErrorStatus appendItem(AmdtSymbolLibObject* pObj, AcDbObjectId& id, bool bCheckValidName=true);

  // Update existing item
  virtual Acad::ErrorStatus modifyItem(const ACHAR *entryName, AcmSymbol *pSym);
};
MAKE_ACDBOPENOBJECT_FUNCTION(AmdtFCFLibrary);
DBREF_DECLARE(AmdtFCFLibrary)

//////////////////////////////////////////////////////////////////////////
// Global function
DllImpExp bool getAcmFCFLibrary(AcDbObjectId &libId, AcDbDatabase *pDb=NULL, bool bCreateIfNotExist=true);


#endif //